/*
 * File:   input_capture_2020.c
 * Author: Alcides Ramos
 *
 * Created on 17 de septiembre de 2020, 01:30 AM
 */

#pragma config BWRP = WRPROTECT_OFF     // Boot Segment Write Protect (Boot Segment may be written)
#pragma config BSS = NO_FLASH           // Boot Segment Program Flash Code Protection (No Boot program Flash segment)

// FGS
#pragma config GWRP = OFF               // General Code Segment Write Protect (User program memory is not write-protected)
#pragma config GSS = OFF                // General Segment Code Protection (User program memory is not code-protected)

// FOSCSEL
#pragma config FNOSC = PRIPLL           // Oscillator Mode (Primary Oscillator (XT, HS, EC) w/ PLL)
#pragma config IESO = OFF               // Internal External Switch Over Mode (Start-up device with user-selected oscillator source)

// FOSC
#pragma config POSCMD = XT              // Primary Oscillator Source (XT Oscillator Mode)
#pragma config OSCIOFNC = OFF           // OSC2 Pin Function (OSC2 pin has clock out function)
#pragma config IOL1WAY = OFF            // Peripheral Pin Select Configuration (Allow Multiple Re-configurations)
#pragma config FCKSM = CSDCMD           // Clock Switching and Monitor (Both Clock Switching and Fail-Safe Clock Monitor are disabled)

// FWDT
#pragma config WDTPOST = PS32768        // Watchdog Timer Postscaler (1:32,768)
#pragma config WDTPRE = PR128           // WDT Prescaler (1:128)
#pragma config WINDIS = OFF             // Watchdog Timer Window (Watchdog Timer in Non-Window mode)
#pragma config FWDTEN = OFF             // Watchdog Timer Enable (Watchdog timer enabled/disabled by user software)

// FPOR
#pragma config FPWRT = PWR128           // POR Timer Value (128ms)
#pragma config ALTI2C = OFF             // Alternate I2C  pins (I2C mapped to SDA1/SCL1 pins)
#pragma config LPOL = ON                // Motor Control PWM Low Side Polarity bit (PWM module low side output pins have active-high output polarity)
#pragma config HPOL = ON                // Motor Control PWM High Side Polarity bit (PWM module high side output pins have active-high output polarity)
#pragma config PWMPIN = ON              // Motor Control PWM Module Pin Mode bit (PWM module pins controlled by PORT register at device Reset)

// FICD
#pragma config ICS = PGD1               // Comm Channel Select (Communicate on PGC1/EMUC1 and PGD1/EMUD1)
#pragma config JTAGEN = OFF             // JTAG Port Enable (JTAG is Disabled)

// #pragma config statements should precede project file includes.
// Use project enums instead of #define for ON and OFF.

#include <xc.h>
#define    FCY    80000000UL // frecuencia del reloj
#define led1  _LATB14  //timer 1 de 16 bits
#define led2  _LATB15   // timers 32 32 bits
#define disparo  _LATA1

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "libpic30.h"



#include<uart.h>
#include "pps.h"// incluye libreria de pines remapeables
#include  <timer.h>
#include "incap.h"

// registro para configurar el puerto serial
unsigned int config1=0,config2=0;

float ancho1,ancho2,ancho3,ancho4;
float dis1,dis2,dis3,dis4;
unsigned int pulso_1,pulso_2,pulso_3,pulso_4;



unsigned char texto[100];
#define prescalador 64  // prescalador a usar


#include "xc.h"
#include "config_Input_capture_33f_util.h"

void Uart1_write_text_const(const char *info)
{
 while(*info)
 {
     WriteUART1(*info++);
     while (_UTXBF==1);//espera que se enve el dato
 }
}

void Uart1_write_text( char *info)
{
 while(*info)
    {
    WriteUART1(*info++);
    while (_UTXBF==1);//espera que se enve el dato
    }
}



void habilita()
{
 //nivel de prioridad interrupcion CPU  //0 habilita interrupciones
_IPL3=0;
INTCON1bits.NSTDIS=0; //PARA PODER HACER EL CAMBIO DEBE STAR EN CERO HABILITADO EL ANIDAMIENTO
_IPL2=0;
_IPL1=0;
_IPL0=0;
_NSTDIS=0; //HABILITA ANINAMIENTO INTERRUPCIONES
}


int main(void) 
{
//Configuracin de operacion.
//CONFIGURA VELOCIDAD DE OPERACION    A 80 MEGAHERT CON CRISTAL DE 4 MEGA

//DEJAMOS N1 Y N2  EN 2

//VELOCIDAD= 4M*M/(N1*N2)= 4M*80/4=80M
  CLKDIVbits.PLLPRE = 0;      // N1 = 2
  CLKDIVbits.PLLPOST = 0;     // N2 = 2
   PLLFBD=78; // selecciona  M=80;  siempre lo deseado menos 2;

  AD1PCFGL=0xffff;// todo digital
  //puertos como salida
 TRISB=0x0;
 TRISA=0x0; 
 _TRISB2=1;// entrada1
 _TRISB3=1;// entrada2
 _TRISB4=1;// entrada3
 _TRISB5=1;// entrada3
 
 LATB=0;
 // configuracion de remapeables
 
 
 PPSUnLock;// desbloquea cionfiguracion de perifericos

 iPPSOutput(OUT_PIN_PPS_RP0,OUT_FN_PPS_U1TX);    // con figura rp14 como salida a u1tx
 iPPSInput(IN_FN_PPS_IC1,IN_PIN_PPS_RP2);  // con figuraRP2 como entrada IC1
iPPSInput(IN_FN_PPS_IC2,IN_PIN_PPS_RP3);  // con figuraRP3 como entrada IC2
iPPSInput(IN_FN_PPS_IC7,IN_PIN_PPS_RP4);  // con figuraRP4 como entrada IC7
iPPSInput(IN_FN_PPS_IC8,IN_PIN_PPS_RP5);  // con figuraRP5 como entrada IC8

 PPSLock;// bloquea configuracion periferico
 
 // rx no se va a usar por ahora
 //ahora si configura el puerto serial
 config1= UART_EN & UART_IDLE_CON & UART_IrDA_DISABLE & UART_MODE_SIMPLEX &
          UART_UEN_00 & UART_DIS_WAKE & UART_DIS_LOOPBACK & UART_DIS_ABAUD & 
         UART_BRGH_SIXTEEN &  UART_NO_PAR_8BIT & UART_1STOPBIT;
 
 config2=  UART_INT_TX_BUF_EMPTY  & UART_TX_ENABLE & UART_INT_RX_3_4_FUL &
            UART_ADR_DETECT_DIS & UART_RX_OVERRUN_CLEAR & UART_IrDA_POL_INV_ZERO &
            UART_SYNC_BREAK_DISABLED;
 
 OpenUART1 (config1, config2, 259);// se se saca de excel consume menos recursos
  Uart1_write_text_const("INICIANDO\r\n");
  config_inputcapure();
    
    habilita();
    while (1)
    {
   LATBbits.LATB13=!LATBbits.LATB13;
 __delay_ms(500);

  disparo=0;
  __delay_us(10);
  disparo=1;
   
        ancho1=((float)pulso_1*(float)prescalador)/40e6;   //  40 es la velocidad de operacion/2
     dis1=ancho1/58e-6;
  
    ancho2=((float)pulso_2*(float)prescalador)/40e6;   //  40 es la velocidad de operacion/2
     dis2=ancho2/58e-6;

    ancho3=((float)pulso_3*(float)prescalador)/40e6;   //  40 es la velocidad de operacion/2
   dis3=ancho3/58e-6;

  
        ancho4=((float)pulso_4*(float)prescalador)/40e6;   //  40 es la velocidad de operacion/2
        dis4=ancho4/58e-6;

  
  sprintf(texto,"dis1=%.1fcm    dis2=%.1fcm   dis3=%.1fcm  dis4=%.1fcm\r\n", dis1,dis2,dis3,dis4);
    Uart1_write_text(texto);

    
    
    }
    
 

    return 0;
}
